Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.util.concurrent
Interface TimeLimiter

All Known Implementing Classes:
  FakeTimeLimiter, SimpleTimeLimiter

    @Beta
    public interface TimeLimiter

Produces proxies that impose a time limit on method calls to the proxied object. For example, to return the value of `target.someMethod()`, but substitute `DEFAULT_VALUE` if this method call takes over 50 ms, you can use this code:

       TimeLimiter limiter = . . .;
       TargetType proxy = limiter.newProxy(
           target, TargetType.class, 50, TimeUnit.MILLISECONDS);
       try {
         return proxy.someMethod();
       } catch (UncheckedTimeoutException e) {
         return DEFAULT_VALUE;
       }

Please see `SimpleTimeLimiterTest` for more usage examples.

Since:
  1.0
Author:
  Kevin Bourrillion

Method Summary
`
`<T> T`
` | `callWithTimeout(Callable<T> callable, long timeoutDuration, TimeUnit timeoutUnit, boolean interruptible)` Invokes a specified Callable, timing out after the specified time limit.
`
`<T> T`
` | `newProxy(T target, Class<T> interfaceType, long timeoutDuration, TimeUnit timeoutUnit)` Returns an instance of `interfaceType` that delegates all method calls to the `target` object, enforcing the specified time limit on each call.

Method Detail

### newProxy

    <T> T newProxy(T target,
                   Class<T> interfaceType,
                   long timeoutDuration,
                   TimeUnit timeoutUnit)

  Returns an instance of `interfaceType` that delegates all method calls to the `target` object, enforcing the specified time limit on each call. This time-limited delegation is also performed for calls to `Object.equals(java.lang.Object)`, `Object.hashCode()`, and `Object.toString()`.

  If the target method call finishes before the limit is reached, the return value or exception is propagated to the caller exactly as-is. If, on the other hand, the time limit is reached, the proxy will attempt to abort the call to the target, and will throw an `UncheckedTimeoutException` to the caller.

  It is important to note that the primary purpose of the proxy object is to return control to the caller when the timeout elapses; aborting the target method call is of secondary concern. The particular nature and strength of the guarantees made by the proxy is implementation-dependent. However, it is important that each of the methods on the target object behaves appropriately when its thread is interrupted.

  Parameters:
    `target` - the object to proxy
    `interfaceType` - the interface you wish the returned proxy to implement
    `timeoutDuration` - with timeoutUnit, the maximum length of time that callers are willing to wait on each method call to the proxy
    `timeoutUnit` - with timeoutDuration, the maximum length of time that callers are willing to wait on each method call to the proxy
  Returns:
    a time-limiting proxy
  Throws:
    `IllegalArgumentException` - if `interfaceType` is a regular class, enum, or annotation type, rather than an interface

### callWithTimeout

    <T> T callWithTimeout(Callable<T> callable,
                          long timeoutDuration,
                          TimeUnit timeoutUnit,
                          boolean interruptible)
                      throws Exception

  Invokes a specified Callable, timing out after the specified time limit. If the target method call finished before the limit is reached, the return value or exception is propagated to the caller exactly as-is. If, on the other hand, the time limit is reached, we attempt to abort the call to the target, and throw an `UncheckedTimeoutException` to the caller.

  Warning: The future of this method is in doubt. It may be nuked, or changed significantly.

  Parameters:
    `callable` - the Callable to execute
    `timeoutDuration` - with timeoutUnit, the maximum length of time to wait
    `timeoutUnit` - with timeoutDuration, the maximum length of time to wait
    `interruptible` - whether to respond to thread interruption by aborting the operation and throwing InterruptedException; if false, the operation is allowed to complete or time out, and the current thread's interrupt status is re-asserted.
  Returns:
    the result returned by the Callable
  Throws:
    `InterruptedException` - if `interruptible` is true and our thread is interrupted during execution
    `UncheckedTimeoutException` - if the time limit is reached
    `Exception`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2012. All Rights Reserved.